/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */
#include <node/processor/indexing/fixedindexer.h>

namespace sstmac { namespace omnetpp {


  fixedindexer::fixedindexer(space* sp, int n) {


    omnetpp_address::ptr addr = sp->begin_iteration();
    for(int i = 0; i < n; i++){
        index.push_back(addr);
        addr = sp->next();
    }

  }

  fixedindexer::~fixedindexer() {

  }
} }
