/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_INDEXING_INDEXER_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_INDEXING_INDEXER_H_INCLUDED

#include <vector>

#include <omnetppaddress.h>

#include <node/processor/space/space.h>
#include <sstmac/common/ptr_type.h>

namespace sstmac { namespace omnetpp {


  class indexer {
  public:

    virtual ~indexer() {

    }

    virtual omnetpp_address::ptr getLocation(int i) {
      return index[i];
    }

  protected:
    std::vector<omnetpp_address::ptr > index;
  };
} }
#endif
