/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "randomindexer.h"

//#include <omnetpp.h>
#include <math.h>

namespace sstmac { namespace omnetpp {


  using namespace std;

  randomindexer::randomindexer(space* sp, int n) {


    list<int> inds;

    omnetpp_address::ptr dummy = omnetpp_address::construct();
    for(int i = 0; i < n; i++){
        inds.push_back(i);
        index.push_back(dummy);
    }

    list<int>::iterator it;
    unsigned int seed = 60065;
    omnetpp_address::ptr addr = sp->begin_iteration();
    for (int i = 0; i < n; i++) {
        int r = rand_r(&seed) % inds.size();
        it = inds.begin();
        advance(it, r);
        index[*it] = addr;
        inds.erase(it);

        addr = sp->next();
    }

  }

  randomindexer::~randomindexer() {

  }

} }
