/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "payloadpod.h"

//#include "SSTSF/Messages/valuepayload.h"

#include "medium_serializer.h"

#include <sstmac/software/libraries/mpi/mpimessage.h>

namespace sstmac { namespace omnetpp {

  payloadpod::~payloadpod()
  {

  }

  void
  doPacking(cCommBuffer *buffer, payloadpod& load)
  {
    if (load.load)
      {
        // std::cout << "packing message type " << load.load->get_type() << endl;
        buffer->pack(load.load->get_type());

        medium_serializer *sst_buff = new medium_serializer(buffer);
        load.load->serialize(sst_buff);
      }
    else
      {
        buffer->pack(-1);
      }
  }

  void
  doUnpacking(cCommBuffer *buffer, payloadpod& load)
  {
    int val;
    buffer->unpack(val);

    medium_serializer *sst_buff = new medium_serializer(buffer);
    if (val >= 0)
      {
        switch (val)
        { //payload type, make a new one
        case sst_message::SST:
          std::cout << "unpacking message type " << (int)sst_message::SST << endl;
          load.load = sst_message::deserialize(sst_buff);
          break;

        case sst_message::MPI:
          load.load = sstmac::sw::mpimessage::deserialize(sst_buff);
          break;

        }
        //load.load->unpack(buffer);
      }
    else
      {
        opp_error("trying to deserialize nothing");
      }

  }

} }
