/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_RESOURCEALLOCATOR_ABSTRACTNODEALLOCATOR_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_RESOURCEALLOCATOR_ABSTRACTNODEALLOCATOR_H_INCLUDED

#include "rackallocator.h"



namespace sstmac { namespace omnetpp {

  /// This is an Allocator that attempts to allocate whole racks at a time
  /// for an application.
  class abstractnodeallocator : public rackallocator
  {
  public:
    abstractnodeallocator(int numOfNodes, int coresPerProc, int procsPerNode,
        int nodesPerRack, int numRacks);
    virtual
    ~abstractnodeallocator();

    virtual space*
    allocate(int num);

  protected:
    int currentRack;
  };
} }
#endif
