/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include "abstractnodespace.h"

namespace sstmac { namespace omnetpp {


  abstractnodespace::abstractnodespace(int st, int en, int nodes, int corepp,
      int ppn, int npr, int nr) :
      rackspace(st, en, nodes, corepp, ppn, npr, nr)
  {


  }

  abstractnodespace::~abstractnodespace()
  {

  }

  omnetpp_address::ptr
  abstractnodespace::next()
  {

    current->node(current->node() + 1);

    if (numRacks >= 0 && current->node() >= nodesPerRack)
      {
        current->rack(current->rack() + 1);
        current->node(0);

        if (current->rack() > endRack)
          {
            begin_iteration(); //reset it
          }
      }

    return omnetpp_address::construct(current);
  }

} }
