/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_ABSTRACTNODESPACE_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_ABSTRACTNODESPACE_H_INCLUDED

#include "rackspace.h"

namespace sstmac { namespace omnetpp {


  /// Space descriptor when using the abstractnodeprocessor, can iterate
  /// over nodes within racks
  class abstractnodespace : public rackspace
  {
  public:
    abstractnodespace(int st, int en, int n, int cpp, int ppn, int npr, int nr);
    virtual
    ~abstractnodespace();

    virtual omnetpp_address::ptr
    next();

    virtual int
    get_num_slots()
    {

      return ((endRack - startRack) + 1) * nodesPerRack;
    }

    //virtual Address getRankMap(int r);

    virtual std::string
    get_name()
    {
      return "abstractnode";
    }

  };
} }
#endif
