/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_SPACE_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_SPACE_H_INCLUDED

#include <omnetppaddress.h>

namespace sstmac { namespace omnetpp {


  class space {
  public:
    space(int n, int cpp, int ppn, int npr, int nr);
    virtual ~space();

    //implement this for iterating over a space
    virtual omnetpp_address::ptr begin_iteration() = 0;
    virtual omnetpp_address::ptr next() = 0;

    //get number of slots in this space
    virtual int get_num_slots() = 0;

    //this function maps ranks to coreid's
    //virtual Address getRankMap(int r) = 0;

    virtual std::string get_name() = 0;

    virtual int get_space_param1() = 0;
    virtual int get_space_param2() = 0;

    int numNodes;
    int coresPerProc;
    int procsPerNode;
    int nodesPerRack;
    int numRacks;

  protected:
    omnetpp_address::ptr current;
  };
} }
#endif

