/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_SYSTEMSPACE_H_INCLUDED
#define SSTMAC_BACKENDS_OMNETPP_NODE_PROCESSOR_SPACE_SYSTEMSPACE_H_INCLUDED

#include "space.h"

namespace sstmac { namespace omnetpp {


  class systemspace: public space {
  public:
    systemspace(int n, int cpp, int ppn, int npr, int nr);
    virtual ~systemspace();

    virtual omnetpp_address::ptr begin_iteration();
    virtual omnetpp_address::ptr next();

    virtual int get_num_slots() {
      if (numRacks > 0)
        return numRacks * nodesPerRack * procsPerNode * coresPerProc;
      else
        return numNodes * procsPerNode * coresPerProc;
    }

    //virtual Address getRankMap(int r);

    virtual std::string get_name() {
      return "system";
    }

    virtual int get_space_param1() {
      return 0;
    }
    virtual int get_space_param2() {
      return 0;
    }




  };
} }
#endif
