/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_COMMON_DEBUG_H_INCLUDED
#define SSTMAC_COMMON_DEBUG_H_INCLUDED

#include <sstmac/common/sstmac-config.h>

#include <sstmac/common/logger.h>

namespace sstmac {

#define SSTMAC_DEBUG if(dbg_.is_active()) dbg_

  /**
   * Just a dummy base class for debug type loggers.
   */
class debug : public logger
{
public:

  debug(std::string namesig, const char* color = logger::black) :
      logger(namesig, &std::cout, true, color)
  {
  }

  debug() : logger() {}  // use this for static variables, then create a new one later


};
} // end of namespace sstmac
#endif
