/*
 *  This file is part of SST/macroscale: 
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top 
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/actor/simplemboxapp.h>

namespace sstmac { namespace sw
  {





  simplemboxapp::simplemboxapp(softwareid id) :
            app(id), initialized_(false)
  {

    mbox_ = simplemailserver::mbox::construct(id);

    register_lib(mbox_);
  }

  /// Access our mailbox.
  const simplembox::ptr
  simplemboxapp::mbox() const
  {

    return mbox_;
  }

  void
  simplemboxapp::compute(timestamp &t, int threads)
  {
    for (int i = 0; i < threads; i++)
      {
        app::compute(t);
      }
  }

  simplembox::ptr
  simplemboxapp::mbox()
  {

    return mbox_;
  }

  /// Goodbye.

  simplemboxapp::~simplemboxapp()
  {
  }




  } } // end of namespace sstmac

