/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_LIBRARIES_COMPUTE_LIB_COMPUTE_MEMMOVE_H_INCLUDED
#define SSTMAC_SOFTWARE_LIBRARIES_COMPUTE_LIB_COMPUTE_MEMMOVE_H_INCLUDED


#include <sstmac/software/libraries/compute/lib_compute_inst.h>

#define BLOCK_SIZE 512

namespace sstmac { namespace sw
{

  class lib_compute_memmove : public lib_compute_inst
  {
    // ------- constructor / boost stuff -------------//

  protected:
    lib_compute_memmove(softwareid id);

  public:
    typedef boost::intrusive_ptr<lib_compute_memmove> ptr;

    virtual
    ~lib_compute_memmove();

    static lib_compute_memmove::ptr
    construct(softwareid id);
    // --------------------------------------//

  public:

    void
    compute_block_access(int bytes);

    virtual std::string
    get_lib_name();



  };

} } //end of namespace sstmac

#endif
