/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#include <sstmac/software/libraries/mpi/mpirequest.h>

namespace sstmac { namespace sw
{

  
  

  mpirequest::~mpirequest()
  {
    //std::cout << "calling mpirequest destructor" << std::endl;
  }


  //
  // Build me a request.
  //
  mpirequest::ptr
  mpirequest::construct(const key::ptr &k)
  {
    mpirequest::ptr retval(new mpirequest(k));
    //retval->set_self(retval);
    return retval;
  }

  void
  mpirequest::complete(const mpimessage::ptr &msg)
  {
    if (msg)
      stat_ = msg->build_status();
    complete_ = true;
  }



}  } //end of namespace sstmac
