
#include <sstmac/hardware/network/topology/hdtorus.h>
#include <sstmac/software/services/launch/allocation/allocationstrategy.h>

namespace sstmac { namespace sw {

  class cartallocation: public allocationstrategy {
    sstmac::hw::hdtorus::ptr network_;
    long xoff_, yoff_, xsize_, ysize_;
    bool relocated_;
    long xorig_, yorig_, xnew_, ynew_;

    cartallocation(long num_avail, const sstmac::hw::hdtorus::ptr& network,
                   long xoff, long yoff,
                   long xsize, long ysize,
                   bool relocated = false,
                   long xorig=-1, long yorig=-1,
                   long xnew=-1, long ynew=-1);
  public:
    virtual ~cartallocation() throw() {}
    typedef boost::intrusive_ptr<cartallocation> ptr;
    static ptr construct(long num_avail, const sstmac::hw::hdtorus::ptr& network,
                         long xoff, long yoff,
                         long xsize, long ysize);
    static ptr construct_relocate_node(long num_avail, const sstmac::hw::hdtorus::ptr& network,
                                       long xoff, long yoff,
                                       long xsize, long ysize,
                                       long xorig, long yorig,
                                       long xnew, long ynew);
    void allocate(int nnode,
        std::set<nodeaddress::ptr, nodeaddress::nodeaddresscomp> &allocation);
  };

}}
