/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_SKELETONS_skeletonfactory_H_INCLUDED
#define SSTMAC_SOFTWARE_SKELETONS_skeletonfactory_H_INCLUDED

#include <sstmac/software/process/app.h>
#include <sstmac/common/ptr_type.h>

#include <map>

namespace sstmac { namespace sw
{

//An application factory for launching
  class skeletonfactory
  {
  public:

    static std::map<std::string, sstmac::sw::app::ptr > apps;
    static void
    init_skeletons();
    static bool initialized_;

  };
} } //end of namespace sstmac

#endif
