/*
 *  This file is part of SST/macroscale:
 *               The macroscale architecture simulator from the SST suite.
 *  Copyright (c) 2009 Sandia Corporation.
 *  This software is distributed under the BSD License.
 *  Under the terms of Contract DE-AC04-94AL85000 with Sandia Corporation,
 *  the U.S. Government retains certain rights in this software.
 *  For more information, see the LICENSE file in the top
 *  SST/macroscale directory.
 */

#ifndef SSTMAC_SOFTWARE_SKELETONS_TEST_TEST_COMPUTE_H_INCLUDED
#define SSTMAC_SOFTWARE_SKELETONS_TEST_TEST_COMPUTE_H_INCLUDED

#include <sstmac/software/process/app.h>

namespace sstmac { namespace sw
{

  class test_compute : public app
  {
  public:
    typedef boost::intrusive_ptr<test_compute> ptr;

    test_compute(softwareid id);
    virtual
    ~test_compute();

    virtual void
    skeleton_main();

    static test_compute::ptr
    construct(softwareid id);

    virtual app::ptr
    clone(softwareid id);

    virtual void
    consume_params(const std::list<std::string> &params);

  private:
    int numIterations_;
  };
} } //end of namespace sstmac

#endif
