
#ifndef SSTMAC_SSTMAC_H_INCLUDED
#define SSTMAC_SSTMAC_H_INCLUDED

#include <sstmac/backends/native/manager.h>
#include <sstmac/common/debug.h>
#include <sstmac/common/errors.h>

//skeletons
#include <sstmac/software/skeletons/skeletonfactory.h>

//network topologies
#include <sstmac/hardware/network/topology/clos.h>
#include <sstmac/hardware/network/topology/composite.h>
#include <sstmac/hardware/network/topology/crossbar.h>
#include <sstmac/hardware/network/topology/fattree.h>
#include <sstmac/hardware/network/topology/gamma.h>
#include <sstmac/hardware/network/topology/hdtorus.h>
#include <sstmac/hardware/network/topology/hypercube.h>
#include <sstmac/hardware/network/topology/ring.h>
#include <sstmac/hardware/network/topology/tbird.h>
#include <sstmac/hardware/network/topology/torus.h>
#include <sstmac/hardware/network/topology/line.h>



//network congestion models
#include <sstmac/hardware/network/congestion/circuit.h>
#include <sstmac/hardware/network/congestion/fullnetwork.h>
#include <sstmac/hardware/network/congestion/ordered_flower.h>
#include <sstmac/hardware/network/congestion/overcommit_flower.h>
#include <sstmac/hardware/network/congestion/sharedcircuit.h>
#include <sstmac/hardware/network/congestion/sharedbuffer.h>
#include <sstmac/hardware/network/congestion/throttle_flower.h>
#include <sstmac/hardware/network/congestion/typical_flower.h>

#include <sstmac/hardware/network/congestion/linearlatency.h>
#include <sstmac/hardware/network/congestion/constantlatency.h>
#include <sstmac/hardware/network/congestion/noisylatency.h>


//launching
#include <sstmac/software/services/launch/instantlaunch.h>


//indexing
#include <sstmac/software/services/launch/indexing/blockindexing.h>
#include <sstmac/software/services/launch/indexing/fixedindexing.h>
#include <sstmac/software/services/launch/indexing/randomindexing.h>
#include <sstmac/software/services/launch/indexing/roundrobinindexing.h>



//allocation
#include <sstmac/software/services/launch/allocation/allocationstrategy.h>


//node models
#include <sstmac/backends/native/components/node/simplenode.h>

//nic models
#include <sstmac/backends/native/components/nic/simplenic.h>

//event managers
#include <sstmac/backends/native/eventmap.h>


#endif
